/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { VerticalAnchoredCategorySeries } from "./VerticalAnchoredCategorySeries";
import { IBarSeries_$type } from "./IBarSeries";
import { DependencyProperty } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { Rect } from "igniteui-react-core";
import { typeCast, fromEnum, runOn, markType, markDep } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { List$1 } from "igniteui-react-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { BarFramePreparer } from "./BarFramePreparer";
import { Pool$1 } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { BarTrendLineManager } from "./BarTrendLineManager";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
export let BarSeries = /*@__PURE__*/ (() => {
    class BarSeries extends VerticalAnchoredCategorySeries {
        get_eb() {
            return true;
        }
        ip() {
            if (!isNaN_(this.io)) {
                return super.ip();
            }
            return Defaults.h;
        }
        get_ey() {
            return true;
        }
        cg() {
            return new BarSeriesView(this);
        }
        vw() {
            return 1;
        }
        cm() {
            if (this.cn == 0) {
                return 2;
            }
            return super.cm();
        }
        o0(a) {
            super.o0(a);
            this.y6 = a;
        }
        get_du() {
            return true;
        }
        ts(a) {
            if (this.xAxis == null || this.yAxis == null || this.vm.f.count == 0) {
                return Rect.empty;
            }
            let b = this.cj.by;
            let c = this.cj.bx;
            let d = this.getEffectiveViewport1(this.cj);
            let e = new ScalerParams(0, b, c, this.xAxis.ch, d);
            let f = this.tc(a);
            let g = this.jf(a, true);
            let h = this.jd(a, true);
            let i = truncate(Math.floor(g / this.wn(this.cj)));
            let j = truncate(Math.floor(h / this.wn(this.cj)));
            let k = i - this.wo(this.cj);
            let l = j - this.wo(this.cj);
            if (k < 0) {
                k = 0;
            }
            if (k > this.vm.f.count - 1) {
                k = this.vm.f.count - 1;
            }
            if (l < 0) {
                l = 0;
            }
            if (l > this.vm.f.count - 1) {
                l = this.vm.f.count - 1;
            }
            let m = this.vm.f._inner[k];
            let n = this.vm.f._inner[l];
            let o = Math.abs(f.y - m[0]);
            let p = Math.abs(f.y - n[0]);
            let q = this.xr(this.vv);
            let r = this.yAxis.k4(b, c, d);
            if (o < p) {
                let s = m[0] - 0.5 * r;
                let t = m[1];
                let u = q;
                return new Rect(0, Math.min(u, t), s, Math.max(u, t) - Math.min(u, t), r);
            }
            else {
                let v = n[0] - 0.5 * r;
                let w = n[1];
                let x = q;
                return new Rect(0, Math.min(x, w), v, Math.max(x, w) - Math.min(x, w), r);
            }
        }
        f4(a, b) {
            if (this.f7(a, b)) {
                return true;
            }
            if (this.ud(a, b)) {
                return true;
            }
            return false;
        }
        constructor() {
            super();
            this.ab = BarSeries.$;
            this.vr = new BarFramePreparer(1, this, this.y6, this, this, this.y6.cu);
        }
        vs(a) {
            let b = typeCast(CategorySeriesView.$, a);
            if (b != null && b.q) {
                if (b.p) {
                    return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), b, this, b.cu);
                }
                else {
                    return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.cy.cv.o, this, b.cu);
                }
            }
            else {
                return this.vr;
            }
        }
        ac() {
            super.ac();
        }
        preferredCategoryMode(a) {
            return 2;
        }
        nj(a, b) {
            super.nj(a, b);
            let c = typeCast(BarSeriesView.$, b);
            if (a && c != null && c.de != null) {
                c.de.count = 0;
            }
        }
        wq() {
            if (this.bi != null) {
                let a = this.bi;
                return a.wq();
            }
            let b = 0;
            for (let c of fromEnum(this.cy.series)) {
                if (c == this) {
                    return b;
                }
                let d = typeCast(IBarSeries_$type, c);
                if (d != null && d.yAxis == this.yAxis && d.getPreferredCategoryMode() == 2) {
                    b++;
                }
            }
            return -1;
        }
        xr(a) {
            let b = 0;
            let c = a.by;
            let d = a.bx;
            let e = this.getEffectiveViewport1(a);
            if (!c.isEmpty && !d.isEmpty && this.xAxis != null) {
                let f = new ScalerParams(0, c, d, this.xAxis.ch, e);
                b = this.xAxis.ej(this.xAxis.l7, f);
            }
            return b;
        }
        aq(a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.yAxis) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.xAxis) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        }
        fo(a) {
            let b = this.cj.by;
            b = b.copy();
            let c = this.cj.bx;
            let d = new Rect(0, 0, 0, 1, 1);
            let e = !b.isEmpty && !c.isEmpty && this.c6 != null ? this.c6.indexOf(a) : -1;
            let f = this.tq(this.cj);
            let g = new ScalerParams(0, d, d, this.xAxis.ch, f);
            let h = new ScalerParams(0, d, d, this.yAxis.ch, f);
            let i = this.yAxis != null ? this.yAxis.ej(e, h) : NaN;
            let j = this.yAxis != null ? this.vr.r(this.yAxis, d, d, f) : 0;
            i += j;
            let k = this.xAxis != null && this.valueColumn != null && e < this.valueColumn.count ? this.xAxis.ej(this.valueColumn.item(e), g) : NaN;
            if (!isNaN_(k)) {
                if (k < b.left + 0.1 * b.width) {
                    k = k + 0.4 * b.width;
                    b.x = k - 0.5 * b.width;
                }
                if (k > b.right - 0.1 * b.width) {
                    k = k - 0.4 * b.width;
                    b.x = k - 0.5 * b.width;
                }
            }
            if (!isNaN_(i)) {
                if (i < b.top + 0.1 * b.height) {
                    i = i + 0.4 * b.height;
                    b.y = i - 0.5 * b.height;
                }
                if (i > b.bottom - 0.1 * b.height) {
                    i = i - 0.4 * b.height;
                    b.y = i - 0.5 * b.height;
                }
            }
            if (this.cr != null) {
                this.cr.au(this.cy, b, true);
            }
            return e >= 0;
        }
        h0() {
            return this.yAxis.k4(this.cj.by, this.cj.bx, this.getEffectiveViewport1(this.cj));
        }
        w5(a, b) {
            super.w5(a, b);
            let c = a.f;
            if (!b.o()) {
                return;
            }
            let d = b.by;
            let e = b.bx;
            let f = this.getEffectiveViewport1(b);
            let g = new ScalerParams(0, d, e, this.xAxis.ch, f);
            let h = this.yAxis;
            let i = new ScalerParams(0, d, e, this.yAxis.ch, f);
            let j = this.xAxis;
            let k = j.ej(j.l7, g);
            let l = this.yAxis.k4(d, e, f);
            let m = typeCast(BarSeriesView.$, b);
            if (isNaN_(l) || isInfinity(l) || isNaN_(k)) {
                m.de.count = 0;
                return;
            }
            this.vu.a2(this, this.we(), runOn(this, this.vf), this.wn(b), this.wo(b));
            this.vu.r = this.y7;
            this.vu.s = this.y8;
            this.vu.k = this.y7;
            this.vu.l = this.y8;
            let n = false;
            let o = this.vu.b;
            if (o != null) {
                n = true;
            }
            let p = this.xAxis.cn;
            let q = p ? this.xAxis : null;
            let r = this.valueColumn.count;
            let s = this.wn(b);
            let t = 0;
            for (let u = 0; u < c.count; ++u) {
                let v = c._inner[u][0] - 0.5 * l;
                let w = c._inner[u][1];
                let x = k;
                x = Math.max(x, -100);
                w = Math.min(w, e.right + 100);
                let y = Math.abs(w - x);
                if (isInfinity(y) || isNaN_(y)) {
                    continue;
                }
                let z = m.de.item(t);
                t++;
                z.height = l;
                z.width = y;
                if (n) {
                    this.w1(c, u, r, h, i, b.q);
                }
                if (z.dataContext != null) {
                    let aa = z.dataContext;
                    if (s == 1) {
                        let ab = this.vu.aw(r, u)[0];
                        if (ab >= 0 && ab < this.c6.count) {
                            if (q != null && q.i$b != null && q.i$b.count > ab) {
                                ab = q.i$b._inner[ab];
                            }
                            aa.item = this.c6.item(ab);
                        }
                    }
                    else {
                        aa.item = null;
                    }
                }
                this.vu.ad(z, false, false, false, false);
                z.ap = this.vu.k;
                z.aq = this.vu.l;
                m.dj(z, Math.min(w, x), v);
            }
            m.de.count = t;
            b.c1(a);
        }
        no(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.xf.cu.g(this.hj);
                    break;
            }
            if (this.xf.c6) {
                this.xf.c5.g$e(a, b, c, d);
            }
            switch (a) {
                case 4:
                    if (this.xAxis != null && !this.xAxis.c1()) {
                        this.pp(true);
                    }
                    break;
                case 1:
                    if (this.xAxis != null && !this.xAxis.c1()) {
                        this.pp(true);
                    }
                    break;
                case 0:
                    if (this.xAxis != null && !this.xAxis.c1()) {
                        this.pp(true);
                    }
                    break;
                case 2:
                    if (this.x5 != null && this.xf.cu.d > 0) {
                        this.pp(true);
                    }
                    break;
                case 3:
                    if (d == this.x5) {
                        if (this.xAxis != null && !this.xAxis.c1()) {
                            this.pp(true);
                        }
                    }
                    break;
            }
        }
        o8(a, b, c, d) {
            super.o8(a, b, c, d);
            switch (b) {
                case VerticalAnchoredCategorySeries.$$p[0]:
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    this.xf.cu.g(this.hj);
                    if (this.xAxis != null && this.xAxis.c1()) {
                        this.pp(false);
                    }
                    break;
                case VerticalAnchoredCategorySeries.$$p[1]:
                    if (c != null) {
                        c.b0(this);
                    }
                    if (d != null) {
                        d.ct(this);
                    }
                    if (this.xf.c6) {
                        this.xf.c5 = CategoryTrendLineManagerFactory.a(this.xf.c5, this.yAxis, this.qr, this, this.c9);
                    }
                    this.xf.cu.g(this.hj);
                    this.pp(false);
                    break;
                case "FastItemsSource":
                    if (this.xAxis != null && !this.xAxis.c1()) {
                        this.xf.cu.g(this.hj);
                        this.pp(this.fq && c != null);
                    }
                    break;
                case "ValueColumn":
                    if (this.xAxis != null && !this.xAxis.c1()) {
                        this.xf.cu.g(this.hj);
                        this.pp(this.fq && this.dn);
                    }
                    break;
                case "SeriesViewer":
                    if (c != null && d == null) {
                        this.np(this.xAxis);
                        this.np(this.yAxis);
                    }
                    if (c == null && d != null) {
                        this.pf(this.xAxis);
                        this.pf(this.yAxis);
                    }
                    this.xf.cu.g(this.hj);
                    this.pp(false);
                    break;
            }
        }
        getPreferredCategoryMode() {
            return this.preferredCategoryMode(this.yAxis);
        }
        get useHighMarkerFidelity() {
            return this.wi;
        }
    }
    BarSeries.$t = /*@__PURE__*/ markType(BarSeries, 'BarSeries', VerticalAnchoredCategorySeries.$, [IBarSeries_$type]);
    BarSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, BarSeries, 'raisePropertyChanged', ['RadiusX:y7:zb', [1, 0], 'RadiusY:y8:zc', [1, 0]]);
    return BarSeries;
})();
/**
 * @hidden
 */
export let BarBucketCalculator = /*@__PURE__*/ (() => {
    class BarBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.i = null;
            this.h = null;
            this.j = 0;
            this.i = a;
        }
        g(a) {
            let b = this.c.by;
            let c = this.c.bx;
            let d = this.c.cw.c6;
            if (b.isEmpty || c.isEmpty || this.i.dd.yAxis == null || d == null || d.count == 0) {
                this.d = 0;
                return;
            }
            let e = typeCast(BarSeries.$, this.c.cw);
            let f = e.to(this.c);
            let g = e.getEffectiveViewport1(this.c);
            let h = new ScalerParams(0, b, c, e.yAxis.ch, g);
            let i = Math.floor(e.yAxis.en(f.top, h, 0));
            let j = Math.ceil(e.yAxis.en(f.bottom, h, 0));
            if (!e.yAxis.ch) {
                j = Math.ceil(e.yAxis.en(f.top, h, 0));
                i = Math.floor(e.yAxis.en(f.bottom, h, 0));
            }
            let k = Math.floor((j - i + 1) * a / f.height);
            this.d = truncate(Math.max(1, k));
            this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
            this.f = truncate(Math.ceil(j / this.d));
        }
        getBucketWithoutUnknowns(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 1.7976931348623157E+308;
            let h = -1.7976931348623157E+308;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                Math.max(h, k);
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        getBucket(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = NaN;
            let h = NaN;
            for (let i = d; i <= e; ++i) {
                let j = b[i];
                if (!isNaN_(g)) {
                    if (!isNaN_(j)) {
                        g = Math.min(g, j);
                        h = Math.max(h, j);
                    }
                }
                else {
                    g = j;
                    h = j;
                }
            }
            if (!isNaN_(g)) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        cacheValues() {
            this.j = this.i.dd.valueColumn.count;
            this.h = this.i.dd.valueColumn.asArray();
        }
        unCacheValues() {
            this.h = null;
        }
    }
    BarBucketCalculator.$t = /*@__PURE__*/ markType(BarBucketCalculator, 'BarBucketCalculator', CategoryBucketCalculator.$);
    return BarBucketCalculator;
})();
/**
 * @hidden
 */
export let BarSeriesView = /*@__PURE__*/ (() => {
    class BarSeriesView extends AnchoredCategorySeriesView {
        constructor(a) {
            super(a);
            this.dd = null;
            this.de = null;
            this.df = null;
            this.dk = new Rectangle();
            this.dd = a;
            this.de = ((() => {
                let $ret = new Pool$1(Rectangle.$);
                $ret.create = runOn(this, this.dl);
                $ret.activate = runOn(this, this.dg);
                $ret.disactivate = runOn(this, this.di);
                $ret.destroy = runOn(this, this.dh);
                return $ret;
            })());
            this.c5 = new BarTrendLineManager();
        }
        au() {
            super.au();
            this.df = new List$1(Rectangle.$, 0);
            if (!this.q) {
                this.dd.ua = Defaults.c;
                this.dd.iu = Defaults.i;
            }
        }
        dl() {
            let a = new Rectangle();
            this.df.add(a);
            a._visibility = 1;
            return a;
        }
        dg(a) {
            a._visibility = 0;
        }
        di(a) {
            a._visibility = 1;
        }
        dh(a) {
            this.df.remove(a);
        }
        dj(a, b, c) {
            if (!this.isDirty) {
                this.as();
            }
            a.o = c;
            a.n = b;
        }
        cv() {
            return new BarBucketCalculator(this);
        }
        bh(a, b) {
            super.bh(a, b);
            let c = a;
            let d = this.bs(b);
            c._fill = d;
            c._stroke = d;
            c.ad = this.e.hk;
        }
        ac(a) {
            return this.df._inner[a];
        }
        ab(a) {
            let b = this.df._inner[a];
            this.dk.n = b.n;
            this.dk.o = b.o;
            this.dk.width = b.width;
            this.dk.height = b.height;
            let c = this.bs(a);
            this.dk._fill = c;
            this.dk._stroke = c;
            this.dk.ad = this.e.hk + 3;
            return this.dk;
        }
        a8(a, b) {
            super.a8(a, b);
            if (a.d) {
                for (let c = 0; c < this.df.count; c++) {
                    let d = this.aa(c, b);
                    this.bf(d, c, b);
                    a.w(d);
                }
            }
        }
        an(a) {
            super.an(a);
            let b = 0;
            let c = new List$1(Rectangle.$, 0);
            for (let d of fromEnum(this.de.a)) {
                c.add(d);
            }
            c.aa((e, f) => {
                if (e.o > f.o) {
                    return -1;
                }
                else if (e.o < f.o) {
                    return 1;
                }
                else {
                    return 0;
                }
            });
            for (let e of fromEnum(c)) {
                this.e.a9.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
            b++;
        }
        af() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.e.s6 = a;
            this.e.ir = 5;
            this.e.is = 5;
            this.e.it = -5;
        }
    }
    BarSeriesView.$t = /*@__PURE__*/ markType(BarSeriesView, 'BarSeriesView', AnchoredCategorySeriesView.$);
    return BarSeriesView;
})();
